# the compiler: gcc for C program, define as g++ for C++
CC = gcc

# Sets all library paths and links
LIBS = -Wl,-rpath=. -I/usr/local/include/voro++ -L/usr/local/lib/ -lvoro++ -L. -lvoro_c_wrapper -lstdc++

# Wrappers (here: calling the C++-to-C wrapper for voro++):
WRAPPERS = voro_c_wrapper.cpp


# Compiler flags:
#  -lm is the math library
#  -O3 adds level 3 optimization
#  -g enables debug information
CFLAGS  = -lm -O3 -g

# Standards to compile with
STANDARD = -std=gnu99

# Warnings: 
#  -w suppresses all compiler warnings
#  -Wall turns on most, but not all, compiler warnings
NO_W    = -w
WARNINGS= -Wall

# The build target executable:
TARGET = Brownian_Dynamics
EXECUTABLE = bd

all: $(TARGET)

$(TARGET): $(TARGET).c
	$(CC) $(TARGET).c -o $(EXECUTABLE) $(CFLAGS) $(NO_W) $(STANDARD) $(WRAPPERS) $(LIBS)

debug: $(TARGET).c
	$(CC) $(TARGET).c -o $(EXECUTABLE) $(CFLAGS) $(WARNINGS) $(STANDARD)  $(WRAPPERS) $(LIBS)

clean:
	$(RM) $(TARGET)

voro:
	g++ -fPIC -shared voro_c_wrapper.cpp -I/usr/local/include/voro++ -o ../bin/libvoro_c_wrapper.so; #gcc Brownian_Dynamics.c -o bd -lm -O3 voro_c_wrapper.cpp -I/usr/local/include/voro++ -L/usr/local/lib/ -lvoro++ -L. -lvoro_c_wrapper -w -lstdc++
